#!/usr/sbin/perl

# This program is to extract steps from testcase file 

if($#ARGV != 2){
	print "Usage: perl extract_step_from_testcase.pl testcaseDir L output \n";
	exit;
}

$testcaseDir = $ARGV[0];
$L = $ARGV[1];
$output = $ARGV[2];


if(-d $testcaseDir){
	open(OUTPUT, ">$output") || die("Could not new output file $output\n");
	opendir(TSTDIR, $testcaseDir) || die("Could not open file $testcaseDir\n");
	while($testcaseFile = readdir(TSTDIR)){
		if(($testcaseFile =~ /_$L_[\d]+\.tst/) || ($testcaseFile =~ /\.tst/)){
			$testcase = extractStep("$testcaseDir//$testcaseFile");
			print "Extracting $testcaseFile\n";
			print OUTPUT ("$testcaseFile,$testcase\n");
		}
	}
	#for($i = 0; $i < $L; $i++){
		#$testcase = extractStep("$testcaseDir\\$i.tst");
		#print "Extracting $i.tst\n";
		#print OUTPUT ("$i.tst,$testcase\n");	
	#}
	close(OUTPUT);
	close(TSTDIR);
}
else{
	print "Wrong testcase directory!\n";
}
	
sub extractStep{
	my($testcasefile) = @_;
	
	$result = "";
	open(TESTCASEFILE, $testcasefile) || die("Could not open testcase file $testcasefile\n");
	while($line = <TESTCASEFILE>){
		if($line =~ /<Window>([\w\W]+)<\/Window>/){
			$result .= "$1,";
		}
		
		if($line =~ /<Component>([\w\W]+)<\/Component>/){
			$result .= "$1,";
		}

		if($line =~ /<Action>([\w\W]+)<\/Action>/){
			$result .= "$1,";
		}
	}
	
	return $result;
}
			
