#!/usr/sbin/perl

# This program is to generate command file

if($#ARGV < 6){
	print "Usage: perl generate_command_3.pl formatFile output startNum stopNum interval tcDir zipMark preLine lastLine tcMark logMark\n";
	exit;
}

$formatFile = $ARGV[0];
$output = $ARGV[1];
$startNum = $ARGV[2];
$stopNum = $ARGV[3];
$interval = $ARGV[4];
$tcDir = $ARGV[5];
$zipMark = $ARGV[6];

open(FORMATFILE, $formatFile) || die("Could not open file $formatFile\n");
@cmdFormat = <FORMATFILE>;
close(FORMATFILE);
$len = @cmdFormat;

@preLine = "";
$preLineLen = 0;
if($#ARGV > 6){
	open(PRELINE, $ARGV[7]) || die("Could not open preline file $ARGV[7]\n");
	@preLine = <PRELINE>;
	$preLineLen = @preLine;
	close(PRELINE);
}

@lastLine = "";
$lastLineLen = 0;
if($#ARGV > 7){
	open(LASTLINE, $ARGV[8]) || die("Could not open lastline file $ARGV[8]\n");
	@lastLine = <LASTLINE>;
	$lastLineLen = @lastLine;
	close(LASTLINE);
}
	
$output_num = 1;
$num = 0;

if($#ARGV > 8){
	$tcMark = $ARGV[9];
	if($tcMark eq "null"){
		$tcMark = "";
	}
}
else{
	$tcMark = "";
}

if($#ARGV > 9){
	$logMark = $ARGV[10];
}
else{
	$logMark = "";
}

print "OUTPUT:$output_$output_num.sh\n";
if($stopNum < $interval){
	open(OUTPUT, ">$output.sh");
}
else{
	$output_file = $output . "_$output_num.sh";
	open(OUTPUT, ">$output_file");
}
if($preLineLen > 0){
	for($i = 0; $i < $preLineLen; $i++){
		print OUTPUT "@preLine[$i]";
		print "$output_num:PRELINE:@preLine[$i]";
	}
}
$moveTestcase = 0;
for($ind = $startNum; $ind <= $stopNum; $ind++){
	if($moveTestcase == 0){
		print OUTPUT "\n";
		if($ind + $interval >= $stopNum){
			$nextStop = $stopNum + 1;
		}
		else{
			$nextStop = $ind + $interval;
		}

		for($i = $ind; $i < $nextStop; $i++){
			print OUTPUT "cp $tcDir/$tcMark$i.tst $TMP/TC/\n";
		}
		print OUTPUT "\n";

		$moveTestcase = 1;
	}

	for($indx = 0; $indx < $len; $indx++){
		$cmdLine = @cmdFormat[$indx];
		$cmdLine =~ s/IND/$tcMark$ind/g;
		$cmdLine =~ s/LL/$output_num/g;
		$cmdLine =~ s/ZIPMARK/$zipMark/g;
		$cmdLine =~ s/LOGMARK/$logMark/g;
		print OUTPUT ("$cmdLine");
	}

	$num += 1;
	if($num == $interval){
		if($ind == $stopNum){
			last;
		}

		if($lastLineLen > 0){
			for($i = 0; $i < $lastLineLen; $i++){
				$cmdLine = @lastLine[$i];
				$cmdLine =~ s/LL/$output_num/g;	
				$cmdLine =~ s/ZIPMARK/$zipMark/g;
				print OUTPUT "$cmdLine";
				print "$output_num:LASTLINE:$cmdLine";	
			}
		}
		close(OUTPUT);
		
		$output_num += 1;
		print "\nOUTPUT:$output$output_num.sh\n";
		$output_file = $output . "_$output_num.sh";
		open(OUTPUT, ">$output_file");
		if($preLineLen > 0){
			for($i = 0; $i < $preLineLen; $i++){
				print OUTPUT "@preLine[$i]";
				print "$output_num:PRELINE:@preLine[$i]";
			}
		}
		$num = 0;
		$moveTestcase = 0;
	}
}

if($lastLineLen > 0){
	for($i = 0; $i < $lastLineLen; $i++){
		$cmdLine = @lastLine[$i];
		$cmdLine =~ s/LL/$output_num/g;	
		$cmdLine =~ s/ZIPMARK/$zipMark/g;
		print OUTPUT "$cmdLine";
		print "$output_num:LASTLINE:$cmdLine";
	}
}
close(OUTPUT);

